From 25b8c8f1cbd719b4be736d8369262fc3897f1629 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 10 2020 04:12:27 +0000
Subject: [PATCH 232/2232] Remove <UniquePtr<CxxString>>::new


CxxString is considered an opaque C type and can never exist in Rust by
value, so this constructor was uncallable.

---

diff --git a/src/cxx.cc b/src/cxx.cc
index 0c1b8af..35dcc95 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -169,10 +169,6 @@ void cxxbridge02$unique_ptr$std$string$null(
     std::unique_ptr<std::string> *ptr) noexcept {
   new (ptr) std::unique_ptr<std::string>();
 }
-void cxxbridge02$unique_ptr$std$string$new(std::unique_ptr<std::string> *ptr,
-                                           std::string *value) noexcept {
-  new (ptr) std::unique_ptr<std::string>(new std::string(std::move(*value)));
-}
 void cxxbridge02$unique_ptr$std$string$raw(std::unique_ptr<std::string> *ptr,
                                            std::string *raw) noexcept {
   new (ptr) std::unique_ptr<std::string>(raw);
diff --git a/src/unique_ptr.rs b/src/unique_ptr.rs
index 4a1392a..f058d5e 100644
--- a/src/unique_ptr.rs
+++ b/src/unique_ptr.rs
@@ -2,7 +2,7 @@ use crate::cxx_string::CxxString;
 use std::ffi::c_void;
 use std::fmt::{self, Debug, Display};
 use std::marker::PhantomData;
-use std::mem::{self, MaybeUninit};
+use std::mem;
 use std::ptr;
 
 /// Binding to C++ `std::unique_ptr<T, std::default_delete<T>>`.
@@ -140,8 +140,6 @@ pub unsafe trait UniquePtrTarget {
 extern "C" {
     #[link_name = "cxxbridge02$unique_ptr$std$string$null"]
     fn unique_ptr_std_string_null(this: *mut *mut c_void);
-    #[link_name = "cxxbridge02$unique_ptr$std$string$new"]
-    fn unique_ptr_std_string_new(this: *mut *mut c_void, value: *mut CxxString);
     #[link_name = "cxxbridge02$unique_ptr$std$string$raw"]
     fn unique_ptr_std_string_raw(this: *mut *mut c_void, raw: *mut CxxString);
     #[link_name = "cxxbridge02$unique_ptr$std$string$get"]
@@ -158,12 +156,6 @@ unsafe impl UniquePtrTarget for CxxString {
         unsafe { unique_ptr_std_string_null(&mut repr) }
         repr
     }
-    fn __new(value: Self) -> *mut c_void {
-        let mut repr = ptr::null_mut::<c_void>();
-        let mut value = MaybeUninit::new(value);
-        unsafe { unique_ptr_std_string_new(&mut repr, value.as_mut_ptr() as *mut Self) }
-        repr
-    }
     unsafe fn __raw(raw: *mut Self) -> *mut c_void {
         let mut repr = ptr::null_mut::<c_void>();
         unique_ptr_std_string_raw(&mut repr, raw);

